/*Version 20190409
ic.net: mudder
a.k.a John Sullivan

This is the original 20160813 code, modified to have the same pinout as the new "lean burn" code.
*/

int QBATTpin=6;  //This is the only change between this version and 20160813
int ACTTRQpin=11;
int MOTFSApin=12;
int MOTFSBpin=13;

char frameorder[]={"ba"};

void setup() {
pinMode(MOTFSApin,OUTPUT);  //clock
pinMode(MOTFSBpin,OUTPUT);  //data
pinMode(QBATTpin,OUTPUT);   //2kHz PWM, 10%=empty, 90%=full
pinMode(ACTTRQpin,OUTPUT);  //2kHz PWM, assist>50%, regen<50%

Serial.begin(115200);

analogWrite(ACTTRQpin,127); //50% duty tells ECU "IMA not delivering torque"
analogWrite(QBATTpin,30);  //12% duty tells ECU battery is nearly empty.  
                            //Note: ECU will Autostop (i.e. stall) if QBATT indicates battery is charged
}

void loop() 
{
  for(int ii=0;ii<sizeof(frameorder);ii++)
  { Serial.println("");
    bitbang_MOTFSB_frame(frameorder[ii]);
  }
}

void bitbang_MOTFSB_frame(char nn)
{  
  if(nn=='a')
  {
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(1);
    bangbit(0);  
    Serial.print("A");
  }
  else if (nn=='b')
  { 
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0);
    bangbit(0); 
    Serial.print("B");
  }
 }

void bangbit(bool jj)
{
    digitalWrite(MOTFSApin,LOW);  //clock low
    digitalWrite(MOTFSBpin,jj);  //set data
    delay(20);  //20 ms
    digitalWrite(MOTFSApin,HIGH);  //clock high
    delay(20);
}
